/*
 * Copyright (c) 2012-2014 Wind River Systems, Inc.
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#include <zephyr.h>
#include <string.h>
#include <sys/printk.h>

#define MY_STACK_SIZE 512
#define MY_PRIORITY 5

K_THREAD_STACK_DEFINE(my_stack_area, MY_STACK_SIZE);

static struct k_work_q my_work_q;

static struct device_info {
    struct k_delayed_work work;
    char name[16];
} my_device;

static void work_handler(struct k_work *item)
{
    struct device_info *the_device =
        CONTAINER_OF(item, struct device_info, work);
    printk("In work handler. Device: %s\n", the_device->name);
}

void main(void)
{
	printk("Hello World! %s\n", CONFIG_BOARD);

	k_work_q_start(&my_work_q, my_stack_area,
               K_THREAD_STACK_SIZEOF(my_stack_area), MY_PRIORITY);
	
	strcpy(my_device.name, "FOO_dev");
	k_delayed_work_init(&my_device.work, work_handler);
	//printk("K_HOURS(160): %d (should be 576,000,000‬) \n", K_HOURS(160));

	//printk("160 hours to ticks: %d\n",k_ms_to_ticks_ceil32(K_HOURS(160)));
	//printk("60 seconds to ticks: %d\n",k_ms_to_ticks_ceil32(60000));

	k_delayed_work_submit_to_queue(&my_work_q, &my_device.work, K_SECONDS(15) /*K_HOURS(160)*/);
}
